diff --git a/pki/base/common/src/com/netscape/cms/profile/def/SubjectDirAttributesExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/SubjectDirAttributesExtDefault.java
index 0259fb36e15c2038b335738451c140962dc13610..04ae8da3326c3f58e0fb9fdcd1ebe121f1f9b4da 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/SubjectDirAttributesExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/SubjectDirAttributesExtDefault.java
@@ -115,7 +115,7 @@ public class SubjectDirAttributesExtDefault extends EnrollExtDefault {
     }
 
 
-    public Enumeration getConfigNames() {
+    public Enumeration<String> getConfigNames() {
         refreshConfigAndValueNames();
         return super.getConfigNames();
     }
@@ -215,21 +215,21 @@ public class SubjectDirAttributesExtDefault extends EnrollExtDefault {
                 {
                     return;
                 }
-                Vector v = parseRecords(value);
+                Vector<NameValuePairs> v = parseRecords(value);
                 int size = v.size();
               
                 boolean critical = ext.isCritical();
 
                 X500NameAttrMap map = X500NameAttrMap.getDefault();
-                Vector attrV = new Vector();
+                Vector<Attribute> attrV = new Vector<Attribute>();
                 for (int i=0; i < size; i++) {
-                    NameValuePairs nvps = (NameValuePairs) v.elementAt(i);
-                    Enumeration names = nvps.getNames();
+                    NameValuePairs nvps = v.elementAt(i);
+                    Enumeration<String> names = nvps.getNames();
                     String attrName = null;
                     String attrValue = null;
                     String enable = "false";
                     while (names.hasMoreElements()) {
-                        String name1 = (String) names.nextElement();
+                        String name1 =  names.nextElement();
 
                         if (name1.equals(ATTR_NAME)) {
                             attrName = nvps.getValue(name1);
@@ -312,16 +312,16 @@ public class SubjectDirAttributesExtDefault extends EnrollExtDefault {
 
             X500NameAttrMap map = X500NameAttrMap.getDefault();
 
-            Vector recs = new Vector();
+            Vector<NameValuePairs> recs = new Vector<NameValuePairs>();
             int num = getNumAttrs();
-            Enumeration e = ext.getAttributesList();
+            Enumeration<Attribute> e = ext.getAttributesList();
             CMS.debug("SubjectDirAttributesExtDefault: getValue: attributesList="+e);
             int i=0;
 
             while (e.hasMoreElements()) {
                 NameValuePairs pairs = new NameValuePairs();
                 pairs.add(ENABLE, "true");
-                Attribute attr = (Attribute)(e.nextElement());
+                Attribute attr = e.nextElement();
                 CMS.debug("SubjectDirAttributesExtDefault: getValue: attribute="+attr);
                 ObjectIdentifier oid = attr.getOid();
                 CMS.debug("SubjectDirAttributesExtDefault: getValue: oid="+oid);
@@ -332,7 +332,7 @@ public class SubjectDirAttributesExtDefault extends EnrollExtDefault {
                     pairs.add(ATTR_NAME, vv);
                 else
                     pairs.add(ATTR_NAME, oid.toString());
-                Enumeration v = attr.getValues();
+                Enumeration<String> v = attr.getValues();
                 
                 // just support single value for now
                 StringBuffer ss = new StringBuffer();
@@ -413,7 +413,7 @@ public class SubjectDirAttributesExtDefault extends EnrollExtDefault {
         num = getNumAttrs();
          
         AttributeConfig attributeConfig = null;
-        Vector attrs = new Vector();
+        Vector<Attribute> attrs = new Vector<Attribute>();
         for (int i = 0; i < num; i++) {
             String enable = getConfig(CONFIG_ENABLE + i); 
             if (enable != null && enable.equals("true")) {
@@ -521,9 +521,9 @@ class AttributeConfig {
         return;
     }
 
-    private Vector str2MultiValues(String attrValue) {
+    private Vector<String> str2MultiValues(String attrValue) {
         StringTokenizer tokenizer = new StringTokenizer(attrValue, ",");
-        Vector v = new Vector();
+        Vector<String> v = new Vector<String>();
         while (tokenizer.hasMoreTokens()) {
             v.addElement(tokenizer.nextToken());
         }
diff --git a/pki/base/common/src/com/netscape/cms/publish/mappers/AVAPattern.java b/pki/base/common/src/com/netscape/cms/publish/mappers/AVAPattern.java
index 9f337cbb435d6540976aa5b4105d1fa8d30391cb..aea489e3d1421c6486ab14da34682740d9678cff 100644
--- a/pki/base/common/src/com/netscape/cms/publish/mappers/AVAPattern.java
+++ b/pki/base/common/src/com/netscape/cms/publish/mappers/AVAPattern.java
@@ -37,6 +37,7 @@ import netscape.ldap.LDAPDN;
 import netscape.security.x509.CertificateExtensions;
 import netscape.security.x509.Extension;
 import netscape.security.x509.GeneralName;
+import netscape.security.x509.GeneralNameInterface;
 import netscape.security.x509.GeneralNames;
 import netscape.security.x509.LdapV3DNStrConverter;
 import netscape.security.x509.OIDMap;
@@ -446,7 +447,7 @@ class AVAPattern {
                         // For now, just give subjectAltName
                         // as an example.
                         if (mValue.equalsIgnoreCase(
-                                SubjectAlternativeNameExtension.NAME)) {
+                                SubjectAlternativeNameExtension.class.getSimpleName())) {
                             try {
                                 GeneralNames subjectNames = (GeneralNames)
                                     ((SubjectAlternativeNameExtension)
@@ -459,7 +460,7 @@ class AVAPattern {
 
                                 int j = 0;
 
-                                for (Enumeration n =
+                                for (Enumeration<GeneralNameInterface> n =
                                         subjectNames.elements();
                                     n.hasMoreElements();) {
 
@@ -561,7 +562,7 @@ class AVAPattern {
             return new String[] { rdn };
         }
 
-        Vector avas = new Vector();
+        Vector<String> avas = new Vector<String>();
 
         StringTokenizer token = new StringTokenizer(rdn, "+");
 
diff --git a/pki/base/common/src/com/netscape/cms/publish/mappers/LdapCaSimpleMap.java b/pki/base/common/src/com/netscape/cms/publish/mappers/LdapCaSimpleMap.java
index 9f605678e00770663bfd046b0315266d36a30259..3cf1bca82a446de11e1ea53557a0048e8496af18 100644
--- a/pki/base/common/src/com/netscape/cms/publish/mappers/LdapCaSimpleMap.java
+++ b/pki/base/common/src/com/netscape/cms/publish/mappers/LdapCaSimpleMap.java
@@ -348,16 +348,16 @@ public class LdapCaSimpleMap implements ILdapMapper, IExtendedPluginInfo {
         return "LdapCaSimpleMap";
     }
 
-    public Vector getDefaultParams() {
-        Vector v = new Vector();
+    public Vector<String> getDefaultParams() {
+        Vector<String> v = new Vector<String>();
 
         v.addElement(PROP_DNPATTERN + "=");
         v.addElement(PROP_CREATECA + "=true");
         return v;
     }
 
-    public Vector getInstanceParams() {
-        Vector v = new Vector();
+    public Vector<String> getInstanceParams() {
+        Vector<String> v = new Vector<String>();
 
         try {
             if (mDnPattern == null) {
diff --git a/pki/base/common/src/com/netscape/cms/publish/mappers/LdapEnhancedMap.java b/pki/base/common/src/com/netscape/cms/publish/mappers/LdapEnhancedMap.java
index c3c269515eecfd316551560bd95a8410edb96f8d..e3c2fa1baca0877485b247ec883c31f93a6a575f 100644
--- a/pki/base/common/src/com/netscape/cms/publish/mappers/LdapEnhancedMap.java
+++ b/pki/base/common/src/com/netscape/cms/publish/mappers/LdapEnhancedMap.java
@@ -124,7 +124,7 @@ public class LdapEnhancedMap
      * for instances of this implementation can be configured through the
      * console.
      */
-    private static Vector defaultParams = new Vector();
+    private static Vector<String> defaultParams = new Vector<String>();
 
     static {
         defaultParams.addElement(PROP_DNPATTERN + "=");
@@ -397,12 +397,12 @@ public class LdapEnhancedMap
         return "LdapEnhancedMap";
     }
 
-    public Vector getDefaultParams() {
+    public Vector<String> getDefaultParams() {
         return defaultParams;
     }
 
-    public Vector getInstanceParams() {
-        Vector v = new Vector();
+    public Vector<String> getInstanceParams() {
+        Vector<String> v = new Vector<String>();
 
         try {
             if (mDnPattern == null) {
@@ -588,7 +588,7 @@ public class LdapEnhancedMap
     /////////////////////////////////
 
     public String[] getExtendedPluginInfo(Locale locale) {
-        Vector v = new Vector();
+        Vector<String> v = new Vector<String>();
 
         v.addElement(PROP_DNPATTERN +
             ";string;Describes how to form the Ldap " +
diff --git a/pki/base/common/src/com/netscape/cms/publish/mappers/LdapSimpleMap.java b/pki/base/common/src/com/netscape/cms/publish/mappers/LdapSimpleMap.java
index c08ec849330ef98f3629704dd19e0cb218b5e15e..192b1d30972f9e31fdc9a6c7fed834791e54de4a 100644
--- a/pki/base/common/src/com/netscape/cms/publish/mappers/LdapSimpleMap.java
+++ b/pki/base/common/src/com/netscape/cms/publish/mappers/LdapSimpleMap.java
@@ -302,15 +302,15 @@ public class LdapSimpleMap implements ILdapMapper, IExtendedPluginInfo {
         return "LdapSimpleMap";
     }
 
-    public Vector getDefaultParams() {
-        Vector v = new Vector();
+    public Vector<String> getDefaultParams() {
+        Vector<String> v = new Vector<String>();
 
         v.addElement(PROP_DNPATTERN + "=");
         return v;
     }
 
-    public Vector getInstanceParams() {
-        Vector v = new Vector();
+    public Vector<String> getInstanceParams() {
+        Vector<String> v = new Vector<String>();
 
         try {
             if (mDnPattern == null) {
diff --git a/pki/base/common/src/com/netscape/cms/publish/mappers/MapAVAPattern.java b/pki/base/common/src/com/netscape/cms/publish/mappers/MapAVAPattern.java
index 26503040148a10eb8b7d5a49ddb0d7f3351f0dd5..667a7c5af7931282e1d4cbaeba03aa93ebc2b941 100644
--- a/pki/base/common/src/com/netscape/cms/publish/mappers/MapAVAPattern.java
+++ b/pki/base/common/src/com/netscape/cms/publish/mappers/MapAVAPattern.java
@@ -30,6 +30,7 @@ import netscape.security.x509.AVA;
 import netscape.security.x509.CertificateExtensions;
 import netscape.security.x509.Extension;
 import netscape.security.x509.GeneralName;
+import netscape.security.x509.GeneralNameInterface;
 import netscape.security.x509.GeneralNames;
 import netscape.security.x509.LdapV3DNStrConverter;
 import netscape.security.x509.OIDMap;
@@ -526,7 +527,7 @@ class MapAVAPattern {
                         // Check the extensions one by one.
                         // For now, just give subjectAltName as an example.
                         if
-                        (mValue.equalsIgnoreCase(SubjectAlternativeNameExtension.NAME)) {
+                        (mValue.equalsIgnoreCase(SubjectAlternativeNameExtension.class.getSimpleName())) {
                             try {
                                 GeneralNames subjectNames = (GeneralNames)
                                     ((SubjectAlternativeNameExtension) ext).get(SubjectAlternativeNameExtension.SUBJECT_NAME);
@@ -535,7 +536,7 @@ class MapAVAPattern {
                                     break;
                                 int j = 0;
 
-                                for (Enumeration n = subjectNames.elements(); n.hasMoreElements();) {
+                                for (Enumeration<GeneralNameInterface> n = subjectNames.elements(); n.hasMoreElements();) {
                                     GeneralName gn = (GeneralName) n.nextElement();
                                     String gname = gn.toString();
 
@@ -617,7 +618,7 @@ class MapAVAPattern {
 
         if (plus == -1) 
             return new String[] { rdn };
-        Vector avas = new Vector();
+        Vector<String> avas = new Vector<String>();
         StringTokenizer token = new StringTokenizer(rdn, "+");
 
         while (token.hasMoreTokens()) 
diff --git a/pki/base/common/src/com/netscape/cms/publish/mappers/MapDNPattern.java b/pki/base/common/src/com/netscape/cms/publish/mappers/MapDNPattern.java
index 547e370ad470dfb5c8167d00d80c2d72d7dae8c3..5de5e3dd99e59fa5f407f2aac18af3711aedf285 100644
--- a/pki/base/common/src/com/netscape/cms/publish/mappers/MapDNPattern.java
+++ b/pki/base/common/src/com/netscape/cms/publish/mappers/MapDNPattern.java
@@ -120,7 +120,7 @@ public class MapDNPattern {
 
     private void parse(PushbackReader in)
         throws ELdapException {
-        Vector rdnPatterns = new Vector();
+        Vector<MapRDNPattern> rdnPatterns = new Vector<MapRDNPattern>();
         MapRDNPattern rdnPattern = null;
         int lastChar = -1;
 
@@ -139,7 +139,7 @@ public class MapDNPattern {
         mRDNPatterns = new MapRDNPattern[rdnPatterns.size()];
         rdnPatterns.copyInto(mRDNPatterns);
 
-        Vector reqAttrs = new Vector();
+        Vector<String> reqAttrs = new Vector<String>();
 
         for (int i = 0; i < mRDNPatterns.length; i++) {
             String[] rdnAttrs = mRDNPatterns[i].getReqAttrs();
@@ -151,7 +151,7 @@ public class MapDNPattern {
         mReqAttrs = new String[reqAttrs.size()];
         reqAttrs.copyInto(mReqAttrs);
 
-        Vector certAttrs = new Vector();
+        Vector<String> certAttrs = new Vector<String>();
 
         for (int i = 0; i < mRDNPatterns.length; i++) {
             String[] rdnAttrs = mRDNPatterns[i].getCertAttrs();
diff --git a/pki/base/common/src/com/netscape/cms/publish/mappers/MapRDNPattern.java b/pki/base/common/src/com/netscape/cms/publish/mappers/MapRDNPattern.java
index 3720d02ddfd8ce3843042ad3edb5fb8dedb79768..65091000cd0c0343cf2289c73ea4146f38b3e604 100644
--- a/pki/base/common/src/com/netscape/cms/publish/mappers/MapRDNPattern.java
+++ b/pki/base/common/src/com/netscape/cms/publish/mappers/MapRDNPattern.java
@@ -123,7 +123,7 @@ class MapRDNPattern {
     private void parse(PushbackReader in)
         throws ELdapException {
         //System.out.println("_________ begin rdn _________");
-        Vector avaPatterns = new Vector();
+        Vector<MapAVAPattern> avaPatterns = new Vector<MapAVAPattern>();
         MapAVAPattern avaPattern = null;
         int lastChar;
 
@@ -156,7 +156,7 @@ class MapRDNPattern {
         mAVAPatterns = new MapAVAPattern[avaPatterns.size()];
         avaPatterns.copyInto(mAVAPatterns);
 
-        Vector reqAttrs = new Vector();
+        Vector<String> reqAttrs = new Vector<String>();
 
         for (int i = 0; i < mAVAPatterns.length; i++) {
             String avaAttr = mAVAPatterns[i].getReqAttr();
@@ -168,7 +168,7 @@ class MapRDNPattern {
         mReqAttrs = new String[reqAttrs.size()];
         reqAttrs.copyInto(mReqAttrs);
 
-        Vector certAttrs = new Vector();
+        Vector<String> certAttrs = new Vector<String>();
 
         for (int i = 0; i < mAVAPatterns.length; i++) {
             String avaAttr = mAVAPatterns[i].getCertAttr();
diff --git a/pki/base/common/src/com/netscape/cms/publish/publishers/LdapEncryptCertPublisher.java b/pki/base/common/src/com/netscape/cms/publish/publishers/LdapEncryptCertPublisher.java
index 902763b48d8cf4e39c7f979d28bd828241b7bc2d..f4dcbb3c0d0a3ed44e05603a03f8ed19b2ae6403 100644
--- a/pki/base/common/src/com/netscape/cms/publish/publishers/LdapEncryptCertPublisher.java
+++ b/pki/base/common/src/com/netscape/cms/publish/publishers/LdapEncryptCertPublisher.java
@@ -91,15 +91,15 @@ public class LdapEncryptCertPublisher implements ILdapPublisher, IExtendedPlugin
 
     }
 
-    public Vector getInstanceParams() {
-        Vector v = new Vector();
+    public Vector<String> getInstanceParams() {
+        Vector<String> v = new Vector<String>();
 
         v.addElement("certAttr=" + mCertAttr);
         return v;
     }
 
-    public Vector getDefaultParams() {
-        Vector v = new Vector();
+    public Vector<String> getDefaultParams() {
+        Vector<String> v = new Vector<String>();
 
         v.addElement("certAttr=" + mCertAttr);
         return v;
@@ -247,11 +247,12 @@ public class LdapEncryptCertPublisher implements ILdapPublisher, IExtendedPlugin
             return at;
         }
 
-        Enumeration vals = attr.getByteValues();
+        @SuppressWarnings("unchecked")
+		Enumeration<byte[]> vals = attr.getByteValues();
         byte[] val = null;
 
         while (vals.hasMoreElements()) {
-            val = (byte[]) vals.nextElement();
+            val = vals.nextElement();
             try {
                 X509CertImpl cert = new X509CertImpl(val);
 
@@ -283,7 +284,7 @@ public class LdapEncryptCertPublisher implements ILdapPublisher, IExtendedPlugin
         CRLExtensions crlentryexts = new CRLExtensions();
 
         try {
-            crlentryexts.set(CRLReasonExtension.NAME, reasonExt);
+            crlentryexts.set(CRLReasonExtension.class.getSimpleName(), reasonExt);
         } catch (IOException e) {
             log(ILogger.LL_FAILURE, CMS.getLogMessage("PUBLISH_SET_CRL_REASON", reason.toString(), e.toString()));
 
@@ -322,7 +323,8 @@ public class LdapEncryptCertPublisher implements ILdapPublisher, IExtendedPlugin
         if (attr == null) {
             return false;
         }
-        Enumeration vals = attr.getByteValues();
+        @SuppressWarnings("unchecked")
+		Enumeration<byte[]> vals = attr.getByteValues();
         byte[] val = null;
 
         while (vals.hasMoreElements()) {
@@ -341,11 +343,12 @@ public class LdapEncryptCertPublisher implements ILdapPublisher, IExtendedPlugin
         if (attr == null) {
             return false;
         }
-        Enumeration vals = attr.getStringValues();
+        @SuppressWarnings("unchecked")
+		Enumeration<String> vals = attr.getStringValues();
         String val = null;
 
         while (vals.hasMoreElements()) {
-            val = (String) vals.nextElement();
+            val = vals.nextElement();
             if (val.equalsIgnoreCase(sval)) {
                 return true;
             }
